package net.sf.brunneng.fusie.core.expressions

import net.sf.brunneng.fusie.core.Variable
import collection.mutable.ListBuffer

/**
 * User: goodg_000
 * Date: 30.03.13
 * Time: 19:33
 */
class ValueExpression[T](val value : T) extends Expression[T] {
  def calculate: T = value

  def collectVariables(res : ListBuffer[Variable[Any]]) {}

  def getChildExpressions: List[Expression[Any]] = List()

  def getProbabilityExpression: Expression[Boolean] = null

  override def toString: String = "ValueExpression(" + value + ")"
}
