package net.sf.brunneng.fusie.engine.fcf

import net.sf.brunneng.fusie.ui.ConsoleUserInteraction
import net.sf.brunneng.fusie.input.pdl.PDLParser

/**
 * User: goodg_000
 * Date: 02.05.13
 * Time: 20:19
 */
object Main {
  def main(args: Array[String]) {
    val input = new PDLParser().parseProblem(
      """required double d = min:1.0 max:5.0 <-"Please enter d.."
        |
        |when
        |   d < 4
        |then
        |   c = "cccsss"
        |
        |when
        |   d > 2
        |then
        |   c = "TTTTT"
        |
        |find c""".stripMargin, null, new ConsoleUserInteraction)
    println(new FCFInferenceEngine().run(input))
  }

}
