package net.sf.brunneng.fusie.input.ast.functions

import net.sf.brunneng.fusie.core.expressions.Expression
import scala.collection.mutable.ListBuffer
import net.sf.brunneng.fusie.core.Variable

/**
 * Created with IntelliJ IDEA.
 * User: evvo
 * Date: 5/29/13
 * Time: 3:30 PM
 * To change this template use File | Settings | File Templates.
 */
class TypeUnsafeFuzzyBooleanFunc(val name: String, val fuzzyFuncShape: String, val testedExpression: Expression[Double],
                             val args: List[Expression[Double]]) extends Expression[Boolean] {
  def calculate: Boolean = throw new NotImplementedError()

  def collectVariables(res: ListBuffer[Variable[Any]]) {
    testedExpression.collectVariables(res)
    args.foreach(e => e.collectVariables(res))
  }

  def getChildExpressions: List[Expression[Any]] = testedExpression :: args

  def getProbabilityExpression: Expression[Boolean] = throw new NotImplementedError()

  override def toString: String = testedExpression.toString + " ~= " + "FuzzyFunc(" + name + ", " + fuzzyFuncShape +
    ", " + args.map(e => e.toString) + ")"
}
