package net.sf.brunneng.fusie.input.ast.operations

import net.sf.brunneng.fusie.core.expressions.Expression
import scala.collection.mutable.ListBuffer
import net.sf.brunneng.fusie.core.Variable

/**
 * User: goodg_000
 * Date: 13.04.13
 * Time: 21:47
 */
class TypeUnsafeBinOp[VT1, VT2, T](val expr1 : Expression[VT1], val expr2 : Expression[VT2],
                                   val op : String) extends Expression[T] with TypeUnsafeOp {
  def calculate: T = throw new NotImplementedError()

  def collectVariables(res: ListBuffer[Variable[Any]]) {
    expr1.collectVariables(res)
    expr2.collectVariables(res)
  }

  def getChildExpressions: List[Expression[Any]] = List(expr1, expr2)

  def getOperation: String = op


  def getProbabilityExpression: Expression[Boolean] = throw new NotImplementedError()

  override def toString: String = "BinOp(" + expr1.toString + " " + op + " " + expr2.toString + ")"
}
