package net.sf.brunneng.fusie.input.ast.operations

import net.sf.brunneng.fusie.core.expressions.Expression
import scala.collection.mutable.ListBuffer
import net.sf.brunneng.fusie.core.Variable

/**
 * User: goodg_000
 * Date: 28.04.13
 * Time: 22:47
 */
class TypeUnsafeUnaryOp[VT1, T](val expr1 : Expression[VT1], val op : String) extends Expression[T] with TypeUnsafeOp {

  def calculate: T = throw new NotImplementedError()

  def collectVariables(res: ListBuffer[Variable[Any]]) {
    expr1.collectVariables(res)
  }

  def getChildExpressions: List[Expression[Any]] = List(expr1)

  def getOperation: String = op

  def getProbabilityExpression: Expression[Boolean] = throw new NotImplementedError()

  override def toString: String = "UnaryOp(" + op + expr1.toString + ")"
}
