package net.sf.brunneng.fusie.input.variables

/**
 * User: goodg_000
 * Date: 20.04.13
 * Time: 11:44
 */
class EnumPossibleValues[T](val constants: List[PossibleValue[T]])
  extends PossibleValuesDefinition[T] with PossibleValuesList[T] {

  def canBeAssigned(v: T): Boolean = constants.find(c => c.value.equals(v)).isDefined

  def getPossibleValues: List[T] = constants.map(c => c.value)
  def getPossibleValuesLabels: List[String] = constants.map(c => c.label)
}
