package net.sf.brunneng.fusie.core.statements

import net.sf.brunneng.fusie.core.Variable
import net.sf.brunneng.fusie.core.expressions.Expression

/**
 * User: goodg_000
 * Date: 30.03.13
 * Time: 23:28
 */
class AssignmentStatement[T](val variable : Variable[T], var expr : Expression[T])
  extends Statement {

  def evaluate() {
    variable.setValue(expr.calculate)
  }

  override def toString: String = "AssignmentStatement(" + variable + " = " + expr + ")"
}
