package net.sf.brunneng.fusie.input.ast.functions

import net.sf.brunneng.fusie.core.expressions.Expression
import scala.collection.mutable.ListBuffer
import net.sf.brunneng.fusie.core.Variable

/**
 * Created with IntelliJ IDEA.
 * User: evvo
 * Date: 5/21/13
 * Time: 11:42 AM
 * To change this template use File | Settings | File Templates.
 */
class TypeUnsafeFunc[T](val name: String, args: List[Expression[_]]) extends Expression[T] {

  def calculate: T = throw new NotImplementedError()

  def collectVariables(res: ListBuffer[Variable[Any]]) {
    args.foreach(e => e.collectVariables(res))
  }

  def getChildExpressions: List[Expression[Any]] = args

  def getProbabilityExpression: Expression[Boolean] = throw new NotImplementedError()

  override def toString: String = "Func(" + name + ", " + args.map(e => e.toString) + ")"
}
