package net.sf.brunneng.fusie.input.variables

/**
 * User: goodg_000
 * Date: 20.04.13
 * Time: 11:28
 */
class DoubleRangePossibleValues(val min: java.lang.Double, val max: java.lang.Double)
  extends PossibleValuesDefinition[Double] {

  def canBeAssigned(v: Double): Boolean = (min == null || v >= min) && (max == null || v <= max)
}
