package net.sf.brunneng.fusie.input.functions

import java.lang.reflect.Method

/**
 * Created with IntelliJ IDEA.
 * User: evvo
 * Date: 5/22/13
 * Time: 2:54 PM
 * To change this template use File | Settings | File Templates.
 */
class Function(val obj: Object, val method: Method) {

  def invoke(args: AnyRef*): AnyRef = {
    method.invoke(obj, args)
  }

  def getSignature(name: String): FunctionSignature = {
    new FunctionSignature(name, method.getParameterTypes)
  }
}
